/* Copyright © 2011 Brandon L Black <blblack@gmail.com>
 *
 * This file is part of gdnsd.
 *
 * gdnsd is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gdnsd is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gdnsd.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _GDNSD_DNSCURVE_H
#define _GDNSD_DNSCURVE_H

#include "config.h"
#include "gdnsd.h"
#include "dnspacket.h"
#include "conf.h"

// Loads random bytes for use after chroot()
void dnscurve_global_setup(void);

// Loads secret key data (globally before i/o threads spawned,
//  but after daemonization)
void load_curve_key_data(void);

F_NONNULL
void dnscurve_iothread_setup(dnspacket_context_t* c, const dns_addr_t* addrconf);

// Wipes out the per-thread copies of the secret key data
F_NONNULL
void destroy_thread_curve_keys(dnspacket_context_t* pctx);

// dnscurve_filter's interface must mirror dnspacket.c:process_dns_query exactly. It acts
//  as a filter between the dnsio code and the real process_dns_query().
F_NONNULL
unsigned int dnscurve_filter(dnspacket_context_t* c, const anysin_t* asin, uint8_t* packet, const unsigned int packet_len);

#endif // _GDNSD_DNSCURVE_H
