/* Copyright © 2011 Brandon L Black <blblack@gmail.com>
 *
 * This file is part of gdnsd.
 *
 * gdnsd is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gdnsd is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gdnsd.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _GDNSD_LIBMONIO_H
#define _GDNSD_LIBMONIO_H

// For satom_t, etc...
#include <gdnsd-satom.h>

/* monio_state == satom, but these define
 * wrappers may make it easier if we
 * have to move to another mechanism
 * later.
 */
#define MONIO_STATE_DOWN   1
#define MONIO_STATE_DANGER 2
#define MONIO_STATE_UP     3
typedef satom_t monio_state_t;
typedef satom_uint_t monio_state_uint_t;
#define monio_state_get(x) satom_get(x)

// If svctype_name is NULL, it will be interpreted as "default".
// Other arguments are required.
// "desc" is just descriptive, used for stats/log output.
typedef struct {
    const char* svctype;
    const char* desc;
    const char* addr;
    monio_state_t* state_ptr;
} monio_info_t;

typedef struct {
    unsigned count;
    monio_info_t* info;
} monio_list_t;

#endif // _GDNSD_LIBMONIO_H
